
// Program:  diagonal_name
// Author:   Chuck Stewart
// Purpose:  A program that outputs an input name along a diagonal.

#include <iostream>
#include <string>
using namespace std;

int main()
{
  cout << "What is your first name? ";
  string first;
  cin >> first;
  
  const string star_line( first.size()+4, '*' );
  const string blanks( first.size()+2, ' ' );
  const string empty_line = '*' + blanks + '*';

  cout << endl
       << star_line << endl
       << empty_line << endl;

  //  Output the interior of the framed greeting, one line at a time.

  for ( string::size_type i = 0; i<first.size(); ++ i )
    {
      //  Job of loop body is to write a row of output containing *'s
      //  in the first (0-th) and last columns, the i-th letter in
      //  column i+2, and a blank everywhere else.

      for ( string::size_type j = 0; j < first.size()+4; ++ j )
        {
          if ( j == 0 || j == first.size()+3 )
            cout << '*';
          else if ( j == i+2 )
            cout << first[i];
          else
            cout << ' ';
        }
      cout << endl;
    }

  cout << empty_line << endl
       << star_line << endl;

  return 0;
}
